/*

   Header file for rmPaintbox.cc

*/

// Manifest Constants

// DrawText() Format Flags
#define DT_TOP              0x00000000
#define DT_LEFT             0x00000000
#define DT_CENTER           0x00000001
#define DT_RIGHT            0x00000002
#define DT_VCENTER          0x00000004
#define DT_BOTTOM           0x00000008
#define DT_WORDBREAK        0x00000010
#define DT_SINGLELINE       0x00000020
#define DT_EXPANDTABS       0x00000040
#define DT_TABSTOP          0x00000080
#define DT_NOCLIP           0x00000100
#define DT_EXTERNALLEADING  0x00000200
#define DT_CALCRECT         0x00000400
#define DT_NOPREFIX         0x00000800
#define DT_INTERNAL         0x00001000
#define DT_EDITCONTROL      0x00002000
#define DT_PATH_ELLIPSIS    0x00004000
#define DT_END_ELLIPSIS     0x00008000
#define DT_MODIFYSTRING     0x00010000
#define DT_RTLREADING       0x00020000
#define DT_WORD_ELLIPSIS    0x00040000

//	stock	logical objects
#define WHITE_BRUSH						0
#define LTGRAY_BRUSH						1
#define GRAY_BRUSH						2
#define DKGRAY_BRUSH						3
#define BLACK_BRUSH						4
#define NULL_BRUSH						5
#define SYSTEM_FONT						13
#define FW_BOLD							700
#define PROOF_QUALITY					2
#define AD_COUNTERCLOCKWISE			1
#define AD_CLOCKWISE						2
#define WHITE_PEN							6
#define BLACK_PEN							7
#define NULL_PEN							8

//	Pen Styles
#define PS_SOLID							0
#define PS_DASH							1		  // -------  
#define PS_DOT								2		  // .......  
#define PS_DASHDOT						3		  // _._._._  
#define PS_DASHDOTDOT					4		  // _.._.._  
#define PS_NULL							5

//	Text alignment	options
#define TA_LEFT							0
#define TA_RIGHT							2
#define TA_CENTER							6

#define TA_TOP								0
#define TA_BOTTOM							8
#define TA_BASELINE						24

//	Background modes
// #define TRANSPARENT						1  // Conflict with dBASE transparent property 
#define OPAQUE								2

//	Device Parameter for	GetDeviceCaps()
#define LOGPIXELSX						88
#define LOGPIXELSY						90

//	ExtFloodFill style flags
#define	FLOODFILLBORDER				0
#define	FLOODFILLSURFACE				1

//	Color	types
#define COLOR_SCROLLBAR					0
#define COLOR_BACKGROUND				1
#define COLOR_ACTIVECAPTION			2
#define COLOR_INACTIVECAPTION			3
#define COLOR_MENU						4
#define COLOR_WINDOW						5
#define COLOR_WINDOWFRAME				6
#define COLOR_MENUTEXT					7
#define COLOR_WINDOWTEXT				8
#define COLOR_CAPTIONTEXT				9
#define COLOR_ACTIVEBORDER				10
#define COLOR_INACTIVEBORDER			11
#define COLOR_APPWORKSPACE				12
#define COLOR_HIGHLIGHT					13
#define COLOR_HIGHLIGHTTEXT			14
#define COLOR_BTNFACE					15
#define COLOR_BTNSHADOW					16
#define COLOR_GRAYTEXT					17
#define COLOR_BTNTEXT					18
#define COLOR_INACTIVECAPTIONTEXT	19
#define COLOR_BTNHIGHLIGHT				20

#define COLOR_3DDKSHADOW				21
#define COLOR_3DLIGHT					22
#define COLOR_INFOTEXT					23
#define COLOR_INFOBK						24

#define COLOR_DESKTOP					COLOR_BACKGROUND
#define COLOR_3DFACE						COLOR_BTNFACE
#define COLOR_3DSHADOW					COLOR_BTNSHADOW
#define COLOR_3DHIGHLIGHT				COLOR_BTNHIGHLIGHT
#define COLOR_3DHILIGHT					COLOR_BTNHIGHLIGHT
#define COLOR_BTNHILIGHT				COLOR_BTNHIGHLIGHT

//	PolyFill() Modes
#define ALTERNATE							1
#define WINDING							2
#define POLYFILL_LAST					2

//	CombineRgn() Styles
#define RGN_AND							1
#define RGN_OR								2
#define RGN_XOR							3
#define RGN_DIFF							4
#define RGN_COPY							5
#define RGN_MIN							RGN_AND
#define RGN_MAX							RGN_COPY

//	Misc others
#define CFALSE								0
#define CTRUE								1
#define TWO_PI								2 * pi()
#define QUARTER							pi() / 2
#define CASTBYTE(a)						(mod(a,2^8))
#define CASTWORD(a)						(mod(a,2^16))
#define LOBYTE(w)							(CASTBYTE(w))
#define HIBYTE(w)							(bitrshift(CASTWORD(w),8))
#define RGB(r,g,b)						(bitor(bitor(LOBYTE(r),bitlshift(LOBYTE(g),8)),bitlshift(LOBYTE(b),16)))
#define GetRValue(rgb)					(LOBYTE(rgb))
#define GetGValue(rgb)					(LOBYTE(bitrshift(rgb, 8)))
#define GetBValue(rgb)					(LOBYTE(bitrshift(rgb, 16)))

// Ternary raster operations
#define SRCCOPY                     0x00CC0020 
#define SRCPAINT                    0x00EE0086 
#define SRCAND                      0x008800C6 
#define NOTSRCCOPY                  0x00330008 

// OBM Stuff
#define GCR_WIDTH                   5
#define GCR_HEIGHT                  7

// For LoadImage
#define IMAGE_BITMAP                0
#define LR_DEFAULTCOLOR             0x0000

// eof